﻿'
' Erstellt mit SharpDevelop.
' Benutzer: Daniel
' Datum: 10.05.2010
' Zeit: 19:04
' 
' Sie können diese Vorlage unter Extras > Optionen > Codeerstellung > Standardheader ändern.
'

Imports System.ComponentModel

' This is the main class of my Direct3D application
Public Class MainClass
	Inherits Form
	
	' The rendering device
	Private device As Device
	
	Public Sub New()
		Me.ClientSize = new System.Drawing.Size(640, 480)
		Me.Text = "Direct3D Project"
	End Sub
	
	Public Function InitializeGraphics() As Boolean
	
		Try
			' Now let's setup the Direct3D stuff
			Dim presentParams As New PresentParameters()
			presentParams.Windowed   = true
			presentParams.SwapEffect = SwapEffect.Discard
			
			' Create the device
			device = new Device(0, DeviceType.Hardware, Me, CreateFlags.SoftwareVertexProcessing, presentParams)
			
			' Setup the event handlers for the device
			AddHandler device.DeviceLost, AddressOf InvalidateDeviceObjects
			AddHandler device.DeviceReset, AddressOf RestoreDeviceObjects
			AddHandler device.Disposing, AddressOf DeleteDeviceObjects
			AddHandler device.DeviceResizing, AddressOf EnvironmentResizing
			
			return True
		Catch ex As DirectXException
			Return False
		End Try
	End Function
	
	Protected Overridable Sub InvalidateDeviceObjects(sender As Object, e As EventArgs)
	
	End Sub
	
	Protected Overridable Sub RestoreDeviceObjects(sender As Object, e As EventArgs)
	
	End Sub
	
	Protected Overridable Sub DeleteDeviceObjects(sender As Object, e As EventArgs)
	
	End Sub
	
	Protected Overridable Sub EnvironmentResizing(sender As Object, e As CancelEventArgs)
	
	End Sub
	
	' This method moves the scene
	Protected Overridable Sub FrameMove()
		' TODO : Frame movement
	End Sub
	
	' This method renders the scene
	Protected Overridable Sub Render()
		If Not device Is Nothing Then
			device.Clear(ClearFlags.Target, Color.Blue, 1.0f, 0)
			device.BeginScene()
			
			' TODO : Scene rendering
			
			device.EndScene()
			device.Present()
		End If
	End Sub
	
	' Our mainloop
	Public Sub Run()
		' While the form is still valid, render and process messages
		Do While Created
			FrameMove()
			Render()
			Application.DoEvents()
		Loop
	End Sub
	
	Protected Overrides Sub OnPaint(e As PaintEventArgs)
		Me.Render()
	End Sub
	
	Protected Overrides Sub OnKeyPress(e As KeyPressEventArgs)
		MyBase.OnKeyPress(e)
		If AscW(e.KeyChar) = CInt(Keys.Escape) Then
			Close()
		End If
	End Sub
	
	' The main entry point for the application
	Shared Sub Main()
		Dim mainClass As New MainClass()
		
		If Not mainClass.InitializeGraphics() Then
			MessageBox.Show("Error while initializing Direct3D")
			Return
		End If
		
		mainClass.Show()
		mainClass.Run()
	End Sub
End Class
